unit DemoForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, vfs, StdCtrls;

type
  TForm1 = class(TForm)
    bNew: TButton;
    bOpen: TButton;
    bClose: TButton;
    eFileName: TEdit;
    cbReadOnly: TCheckBox;
    lTest: TLabel;
    mTest: TMemo;
    bSaveMemo: TButton;
    bLoadMemo: TButton;
    eMemoName: TEdit;
    bFillMemo: TButton;
    Button1: TButton;
    bDynWrite: TButton;
    bDynChange: TButton;
    bClearMemo: TButton;
    mFileList: TMemo;
    bReadDirectory: TButton;
    bTestWriteDir: TButton;
    procedure bTestWriteDirClick(Sender: TObject);
    procedure bReadDirectoryClick(Sender: TObject);
    procedure bClearMemoClick(Sender: TObject);
    procedure bDynChangeClick(Sender: TObject);
    procedure bDynWriteClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure bFillMemoClick(Sender: TObject);
    procedure bLoadMemoClick(Sender: TObject);
    procedure bSaveMemoClick(Sender: TObject);
    procedure bNewClick(Sender: TObject);
    procedure bCloseClick(Sender: TObject);
    procedure bOpenClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  TestDataFile : TVirtualFileSystem;

implementation

{$R *.dfm}

procedure TForm1.bOpenClick(Sender: TObject);
begin
  TestDataFile := TVirtualFileSystem.Create();
  TestDataFile.FileName := eFileName.Text;
  TestDataFile.Open;

  lTest.Caption := TestDataFile.ReadTest();
  //TestDataFile.ReadDummyLarge();
  //lTest.Caption := TestDataFile.ReadDummyRecord();

  bClose.Enabled := true;
  bNew.Enabled := false;
  bOpen.Enabled := false;
  eFileName.Enabled := false;
end;

procedure TForm1.bCloseClick(Sender: TObject);
begin
  TestDataFile.Close();
  bClose.Enabled := false;
  bNew.Enabled := true;
  bOpen.Enabled := true;
  eFileName.Enabled := true;
end;

procedure TForm1.bNewClick(Sender: TObject);
begin
  lTest.Caption := IntToStr(SizeOf(TFileRecord));
  TestDataFile := TVirtualFileSystem.Create();
  TestDataFile.FileName := eFileName.Text;
  TestDataFile.New();
  bClose.Enabled := true;
  bNew.Enabled := false;
  bOpen.Enabled := false;
  eFileName.Enabled := false;
end;

procedure TForm1.bSaveMemoClick(Sender: TObject);
var
  ts: TMemoryStream;
begin
  ts := TMemoryStream.Create();
mTest.Lines.SaveToStream(ts);
ts.Position :=0;
  TestDataFile.WriteStream('',eMemoName.Text, ts );
  ts.Free;
end;

procedure TForm1.bLoadMemoClick(Sender: TObject);
var
  ts: TMemoryStream;
begin
  ts:= TMemoryStream.Create();
  TestDataFile.ReadStream('',eMemoName.Text, ts);
  ts.Position :=0;
  mTest.Lines.LoadFromStream(ts);
  ts.Free;
end;

procedure TForm1.bFillMemoClick(Sender: TObject);
var
  i: integer;
begin
  for i:=0 to 1024 do
  begin
    mTest.Lines.Add('Dit is een test.'+IntToStr(i)+'!');
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  MyStream: TvfsFileStream;
begin
  MyStream := TvfsFileStream.Create(eMemoName.Text, TestDataFile);

//  mTest.Lines.SaveToStream(MyStream);

  //

  mTest.Lines.LoadFromStream(MyStream);

  MyStream.Free;
end;



procedure TForm1.bDynWriteClick(Sender: TObject);
var
  MyStream: TvfsFileStream;
  TxtStream: TFileStream;
begin
  TxtStream:= TFileStream.Create(eMemoName.Text, fmcreate);
  MyStream:= TvfsFileStream.Create(eMemoName.Text, TestDataFile);

  mTest.Lines.SaveToStream(TxtStream);
  mTest.Lines.SaveToStream(MyStream);

  MyStream.Free;
  TxtStream.Free;

end;

procedure TForm1.bDynChangeClick(Sender: TObject);
var
  MyStream: TvfsFileStream;
  MyText: pchar;
begin
  MyStream:=TvfsFileStream.Create(eMemoName.Text, TestDataFile);

  GetMem(MyText, 10+512);
  FillChar(MyText^, 10+512, 'x');

  MyStream.Position := 200+512;
 // MyText:=pchar('hello world at pos 200');
  MyStream.Write(MyText^, 10+511 );

  MyStream.Free;
end;

procedure TForm1.bClearMemoClick(Sender: TObject);
begin
  mTest.Lines.Clear();
  mTest.Lines.Add('mTest');
end;

procedure TForm1.bReadDirectoryClick(Sender: TObject);
begin
  TestDataFile.GetFileList(mFileList.Lines);
end;

procedure TForm1.bTestWriteDirClick(Sender: TObject);
var
  MyRecord: TFileRecord;
  MyStream: TVFSFileStream;
  MyFileStream: TFileStream;
  i: integer;
begin
mFileList.Lines.Clear();

//Write en of Read gaat de fout in met posities....

  //Write
  MyStream:=TVFSFileStream.Create('mytest.dat',TestDataFile);
  //MyFileStream:=TFileStream.Create('mytest.dat',fmcreate);

  TestDataFile.GetFileList(mFileList.Lines);

  for i:=0 to 3 do
  begin
    FillChar(MyRecord, 272, 0);
    MyRecord.filename:='mytest'+IntToStr(i)+'.txt';
    MyRecord.filesize:=7;
    MyRecord.startblock:=i;
    MyStream.Write(MyRecord, SizeOf(TFileRecord) );
    //MyFileStream.Write(MyRecord, SizeOf(TFileRecord) );
    //MyStream.Position := MyStream.Position + 1;
    mFileList.Lines.Add(MyRecord.filename+' '+IntToStr(MyStream.Position) );
  end;

  //MyFileStream.Free;
  MyStream.Free;


  //Read
  TestDataFile.GetFileList(mFileList.Lines);
  mFileList.Refresh;

  MyStream:=TVFSFileStream.Create('mytest.dat',TestDataFile);
  MyStream.Position :=0;
  for i:=0 to 3 do
  begin
    //MyStream.Position := i * SizeOf(MyRecord); //eigenlijk niet nodig?

    FillChar(MyRecord, 272, 0);
    MyRecord.filename:='';
    MyRecord.filesize:=0;
    MyRecord.startblock:=0;

//    MyStream.Position :=0;
    MyStream.Read(MyRecord, SizeOf(TFileRecord) );
    //MyStream.Position := MyStream.Position +1;
    mFileList.Lines.Add(MyRecord.filename +' '+IntToStr(MyStream.Position));
  end;

  MyStream.Free;


end;

end.
